﻿namespace PhysicsUnitsLib {

	public struct Meter {
		public double Value;

		public Meter(double value) => Value = value;

		public static Meter operator +(Meter m1, Meter m2) => new Meter(m1.Value + m2.Value);

		public static Meter operator -(Meter m1, Meter m2) => new Meter(m1.Value - m2.Value);

		public static MeterPerSecond operator /(Meter m, Second s) => new MeterPerSecond(m.Value / s.Value);

		public static bool operator <(Meter m1, Meter m2) => m1.Value < m2.Value;

		public static bool operator >(Meter m1, Meter m2) => m1.Value > m2.Value;

		public static bool operator <=(Meter m1, Meter m2) => m1.Value <= m2.Value;

		public static bool operator >=(Meter m1, Meter m2) => m1.Value >= m2.Value;

		public override string ToString() => Value.ToString() + " m";
	}

	public struct Second {
		public double Value;

		public Second(double value) => Value = value;

		public static Second operator +(Second m1, Second m2) => new Second(m1.Value + m2.Value);

		public static Second operator -(Second m1, Second m2) => new Second(m1.Value - m2.Value);

		public override string ToString() => Value.ToString() + " s";
	}

	public struct MeterPerSecond {
		public double Value;

		public MeterPerSecond(double value) => Value = value;

		public static MeterPerSecond operator +(MeterPerSecond m1, MeterPerSecond m2) => new MeterPerSecond(m1.Value + m2.Value);

		public static MeterPerSecond operator -(MeterPerSecond m1, MeterPerSecond m2) => new MeterPerSecond(m1.Value - m2.Value);

		public static Meter operator *(MeterPerSecond mps, Second s) => new Meter(mps.Value * s.Value);

		public static MeterPerSecond operator *(MeterPerSecond m, int c) => new MeterPerSecond(m.Value * c);

		public static MeterPerSecond operator *(int c, MeterPerSecond m) => m * c;

		public override string ToString() => Value.ToString() + " m/s";

		// public static implicit operator double(MeterPerSecond mps) => mps.Value;
	}

}
